Package tigase.workgroupqueues.modules.agent

## Class OfferModule

- java.lang.Object
- - tigase.workgroupqueues.modules.AbstractModule
  - - tigase.workgroupqueues.modules.agent.OfferModule

- All Implemented Interfaces:
    `Module`

      @Bean(name="AgentOfferModule",
            active=true)
      public class OfferModule
      extends AbstractModule

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ID` |

    - ### Fields inherited from class tigase.workgroupqueues.modules.AbstractModule

      `writer, XMLNS`

    - ### Fields inherited from interface tigase.component.modules.Module

      `EMPTY_FEATURES`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `OfferModule()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String[]` | `getFeatures()` | Returns XMPP features offered by module.
    `Criteria` | `getModuleCriteria()` | Returns critera used by Component to select module to handle incoming stanza.
    `void` | `process​(Packet packet)` | Process incoming stanza.
    `void` | `sendAgentInvitation​(BareJID roomJID, Agent agent, User user, Queue queue, java.lang.String reason)` |
    `void` | `sendOffer​(User user, Agent toAgent, int timeout)` |
    `void` | `sendOfferRevoke​(User user, Agent toAgent, java.lang.String reason)` | Send revocation of earlier offer to chat to a user.

    - ### Methods inherited from class tigase.workgroupqueues.modules.AbstractModule

      `write, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface tigase.component.modules.Module

      `canHandle`

- - ### Field Detail

    - #### ID

          public static final java.lang.String ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### OfferModule

          public OfferModule()

  - ### Method Detail

    - #### getFeatures

          public java.lang.String[] getFeatures()

      Description copied from interface: `Module`
      Returns XMPP features offered by module. Features will be returned by Service Discovery.
      Returns:
        array of features or `null`.

    - #### getModuleCriteria

          public Criteria getModuleCriteria()

      Description copied from interface: `Module`
      Returns critera used by Component to select module to handle incoming stanza.
      Returns:
        criteria of selecting module.

    - #### process

          public void process​(Packet packet)
                       throws ComponentException,
                              TigaseStringprepException

      Description copied from interface: `Module`
      Process incoming stanza.
      Parameters:
        `packet` - received `stanza`.
      Throws:
        `ComponentException` - if stanza can't be processed correctly. ComponentException is converted to error stanza and returned to stanza sender.
        `TigaseStringprepException` - if there was an error during stringprep processing.

    - #### sendAgentInvitation

          public void sendAgentInvitation​(BareJID roomJID,
                                          Agent agent,
                                          User user,
                                          Queue queue,
                                          java.lang.String reason)
                                   throws TigaseStringprepException

      Throws:
        `TigaseStringprepException`

    - #### sendOffer

          public void sendOffer​(User user,
                                Agent toAgent,
                                int timeout)
                         throws TigaseStringprepException

      Throws:
        `TigaseStringprepException`

    - #### sendOfferRevoke

          public void sendOfferRevoke​(User user,
                                      Agent toAgent,
                                      java.lang.String reason)
                               throws TigaseStringprepException

      Send revocation of earlier offer to chat to a user.
      Parameters:
        `user` - user which offer is revoked.
        `toAgent` - agent to send revocation to him.
        `reason` - free form text explaining the reason the offer was revoked.
      Throws:
        `TigaseStringprepException` - in case of invalid JID.